﻿Imports System.Drawing.Printing
Public Class Form1

    Dim arraylist() As String
    Dim lastindex As Integer
    Dim len As Integer
    Dim getname As String
    Dim getext As String


    Private Sub btnBrowseRpt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseRpt.Click
        Reportlist.Items.Clear()
        Reportlist.Enabled = False
        lblSelectReport.Enabled = False
        Reportlist.Text = ""
        OpenFileDialog1.Filter = "XML Files|*.xml"
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            LoadReport()
        End If
    End Sub

    Public Sub LoadReport()
        Try
            tbReportDefName.Text = OpenFileDialog1.FileName
            arraylist = C1Report1.GetReportInfo(OpenFileDialog1.FileName)
            arraylist.Count()
            For i = 0 To arraylist.Count - 1
                Reportlist.Items.Add(arraylist(i).ToString)
            Next
            Reportlist.Enabled = True
            lblSelectReport.Enabled = True
            tbReportDefName.Enabled = True
        Catch ex As Exception
            MsgBox("Invalid Report File")
            tbReportDefName.Text = ""
            tbReportDefName.Enabled = False
        End Try
    End Sub

    Private Sub btnBrowsePrintDoc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowsePrintDoc.Click
        OpenFileDialog1.Filter = "c1d Files|*.c1d|c1dx Files|*.c1dx"
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            LoadPrintDoc()
        End If
    End Sub

    Public Sub LoadPrintDoc()
        Try
            tbPrintDocName.Text = OpenFileDialog1.FileName
            C1PrintDocument1.Load(OpenFileDialog1.FileName)
            tbPrintDocName.Enabled = True
        Catch ex As Exception
            MsgBox("Invalid Report File")
            tbPrintDocName.Text = ""
            tbPrintDocName.Enabled = False
        End Try
        lastindex = OpenFileDialog1.FileName.LastIndexOf("\")
        len = OpenFileDialog1.FileName.Length
        getname = OpenFileDialog1.FileName.Substring((lastindex + 1), (len - (lastindex + 1)))
        RemoveExistingFile("doc")
        lbSelectedList.Items.Add("Doc: " + getname)
    End Sub

    Private Sub btnBrowseRDL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowseRDL.Click
        OpenFileDialog1.Filter = "rdl Files|*.rdl"
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            LoadRdlReport()
        End If
    End Sub

    Public Sub LoadRdlReport()
        Try
            tbRDLRepName.Text = OpenFileDialog1.FileName
            C1RdlReport1.Load(OpenFileDialog1.FileName)
            C1RdlReport1.Render()
            tbRDLRepName.Enabled = True
        Catch ex As Exception
            MsgBox("Invalid Report File")
            tbRDLRepName.Text = ""
            tbRDLRepName.Enabled = False
        End Try
        lastindex = OpenFileDialog1.FileName.LastIndexOf("\")
        len = OpenFileDialog1.FileName.Length
        getname = OpenFileDialog1.FileName.Substring(lastindex + 1, (len - (lastindex + 1)))
        RemoveExistingFile("rdl")
        lbSelectedList.Items.Add("Rdl: " + getname)
    End Sub

    Private Sub btnMerge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMerge.Click
        MergeReports()
        C1PrintPreviewControl1.Document = C1MultiDocument1
    End Sub

    Public Sub MergeReports()
        C1MultiDocument1.Items.Add(C1Report1.C1Document)
        C1MultiDocument1.Items.Add(C1PrintDocument1)
        C1MultiDocument1.Items.Add(C1RdlReport1.C1Document)
    End Sub

    Private Sub Reportlist_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Reportlist.SelectedIndexChanged
        Try
            C1Report1.Load(OpenFileDialog1.FileName.ToString, Reportlist.SelectedItem)
            RemoveExistingFile("rpt")
            lbSelectedList.Items.Add("Rpt: " + Reportlist.SelectedItem)
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click
        tbReportDefName.Text = ""
        Reportlist.Text = ""
        lblSelectReport.Enabled = False
        Reportlist.Enabled = False
        tbPrintDocName.Text = ""
        tbRDLRepName.Text = ""
        lbSelectedList.Items.Clear()
    End Sub

    Public Sub RemoveExistingFile(ByVal ext As String)
        If lbSelectedList.Items.Count > 0 Then
            For Each item In lbSelectedList.Items
                getext = item.Substring(0, 3)
                If getext = "Rpt" And ext = "rpt" Then
                    lbSelectedList.Items.Remove(item)
                ElseIf getext = "Doc" And ext = "doc" Then
                    lbSelectedList.Items.Remove(item)
                ElseIf getext = "Rdl" And ext = "rdl" Then
                    lbSelectedList.Items.Remove(item)
                End If
            Next
        End If
    End Sub

End Class
